// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_ENTRYCOMPLETION_H
#define _GTKMM_ENTRYCOMPLETION_H

#include <glibmm.h>

/* $Id: entrycompletion.hg,v 1.6 2003/12/09 06:42:51 murrayc Exp $ */

/* Copyright (C) 2003 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/widget.h>
#include <gtkmm/treemodel.h>
 

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkEntryCompletion GtkEntryCompletion;
typedef struct _GtkEntryCompletionClass GtkEntryCompletionClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class EntryCompletion_Class; } // namespace Gtk
namespace Gtk
{

class Entry;


class EntryCompletion : public Glib::Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef EntryCompletion CppObjectType;
  typedef EntryCompletion_Class CppClassType;
  typedef GtkEntryCompletion BaseObjectType;
  typedef GtkEntryCompletionClass BaseClassType;

private:  friend class EntryCompletion_Class;
  static CppClassType entrycompletion_class_;

private:
  // noncopyable
  EntryCompletion(const EntryCompletion&);
  EntryCompletion& operator=(const EntryCompletion&);

protected:
  explicit EntryCompletion(const Glib::ConstructParams& construct_params);
  explicit EntryCompletion(GtkEntryCompletion* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~EntryCompletion();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GtkEntryCompletion*       gobj()       { return reinterpret_cast<GtkEntryCompletion*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GtkEntryCompletion* gobj() const { return reinterpret_cast<GtkEntryCompletion*>(gobject_); }

  GtkEntryCompletion* gobj_copy();

private:


  EntryCompletion();
public:
  
  static Glib::RefPtr<EntryCompletion> create();


  //Careful, this actually returns a GtkWidget*, so it might not always be a GtkEntry in future GTK+ versions.
  
  Entry* get_entry();
  
  const Entry* get_entry() const;

  
  void set_model(const Glib::RefPtr<TreeModel>& model);
  
  Glib::RefPtr<TreeModel> get_model();
  
  Glib::RefPtr<const TreeModel> get_model() const;

  /// For example, bool on_match(const Glib::ustring& key, const TreeModel::const_iterator& iter);
  //TODO: Can we really use references in slots? murrayc.
  typedef SigC::Slot2<bool, const Glib::ustring&, const TreeModel::const_iterator&> SlotMatch;
  void set_match_func(const SlotMatch& slot);
  
  
  void set_minimum_key_length(int length);
  
  int get_minimum_key_length() const;
  
  void complete();

  //We reordered the parameters, compared to the C version, so that we can have method overloads without the index.
  //TODO: Find out how many actions are already present so we can add it to the end.
  //TODO: Find out what an "action" is here.
  void insert_action_text(const Glib::ustring& text, int index);
  
  void insert_action_markup(const Glib::ustring& markup, int index);
  

  //TODO: Change default - it would be nicer to delete the last action instead of the first.
  
  void delete_action(int index = 0);

  
  void set_text_column(const TreeModelColumnBase& column);
  
  void set_text_column(int column);

  //TODO: The C++ iterator needs to know about the model. We need some custom stuff here.
  //but I think I've done it elsewhere. murrayc:
  //_WRAP_SIGNAL(bool match_selected(const TreeModel::iterator& iter), match_selected)
  
  /**
   * @par Prototype:
   * <tt>void %action_activated(int index)</tt>
   */
  Glib::SignalProxy1< void,int > signal_action_activated();


  //We completely hand-code this signal because we want to change how the parameters are wrapped,
  //because we need both the iter and the model to make the C++ iter.
  

  /**
   * @par Prototype:
   * <tt>bool %match_selected(const TreeModel::iterator& iter)</tt>
   */
  Glib::SignalProxy1< bool, const TreeModel::iterator& > signal_match_selected();

  
protected:

  //Default Signal Handler:
  virtual bool on_match_selected(const TreeModel::iterator& iter);


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_action_activated(int index);


};

} // namespace Gtk


namespace Glib
{
  /** @relates Gtk::EntryCompletion */
  Glib::RefPtr<Gtk::EntryCompletion> wrap(GtkEntryCompletion* object, bool take_copy = false);
}


#endif /* _GTKMM_ENTRYCOMPLETION_H */

