// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_FILECHOOSER_H
#define _GTKMM_FILECHOOSER_H

#include <glibmm.h>

/* $Id: filechooser.hg,v 1.3 2003/11/04 18:11:36 murrayc Exp $ */

/* Copyright (C) 2003 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/widget.h>
#include <gtkmm/filefilter.h>
#include <glibmm/interface.h>


#include <gtk/gtkfilechooser.h> //TODO: Remove C header.


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkFileChooser GtkFileChooser;
typedef struct _GtkFileChooserClass GtkFileChooserClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class FileChooser_Class; } // namespace Gtk
namespace Gtk
{

/** @addtogroup gtkmmEnums Enums and Flags */

/**
 * @ingroup gtkmmEnums
 */
enum FileChooserAction
{
  FILE_CHOOSER_ACTION_OPEN,
  FILE_CHOOSER_ACTION_SAVE
};

} // namespace Gtk


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Gtk::FileChooserAction> : public Glib::Value_Enum<Gtk::FileChooserAction>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{


/**
 *
 */

class FileChooser : public Glib::Interface
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef FileChooser CppObjectType;
  typedef FileChooser_Class CppClassType;
  typedef GtkFileChooser BaseObjectType;
  typedef GtkFileChooserClass BaseClassType;

private:
  friend class FileChooser_Class;
  static CppClassType filechooser_class_;

  // noncopyable
  FileChooser(const FileChooser&);
  FileChooser& operator=(const FileChooser&);

protected:
  FileChooser(); // you must derive from this class
  explicit FileChooser(GtkFileChooser* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~FileChooser();

  static void add_interface(GType gtype_implementer);

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GtkFileChooser*       gobj()       { return reinterpret_cast<GtkFileChooser*>(gobject_); }

  ///Provides access to the underlying C GObject.  
  const GtkFileChooser* gobj() const { return reinterpret_cast<GtkFileChooser*>(gobject_); }

private:

public:

  
  void set_action(FileChooserAction action);
  
  FileChooserAction get_action() const;
  
  void set_folder_mode(bool folder_mode = true);
  
  bool get_folder_mode() const;
  
  void set_local_only(bool files_only = true);
  
  bool get_local_only() const;
  
  void set_select_multiple(bool select_multiple = true);
  
  bool get_select_multiple() const;

  
  void set_current_name(const Glib::ustring& name);
  
  Glib::ustring get_filename() const;
  
  void set_filename(const Glib::ustring& filename);
  
  void select_filename(const Glib::ustring& filename);
  
  void unselect_filename(const Glib::ustring& filename);
  
  void select_all();
  
  void unselect_all();
  
  Glib::SListHandle<Glib::ustring> get_filenames () const;
  
  void set_current_folder(const Glib::ustring& filename);
  
  Glib::ustring get_current_folder() const;


/* URI manipulation
 */
  
  Glib::ustring get_uri() const;
  
  void set_uri(const Glib::ustring& uri);
  
  void select_uri(const Glib::ustring& uri);
  
  void unselect_uri(const Glib::ustring& uri);
  
  GSList* get_uris() const;

  
  void set_current_folder_uri(const Glib::ustring& uri);
  
  Glib::ustring get_current_folder_uri() const;

/* Preview widget
 */
  
  void set_preview_widget(Gtk::Widget& preview_widget);
  
  const Gtk::Widget* get_preview_widget() const;
  
  Gtk::Widget* get_preview_widget();
  
  void set_preview_widget_active(bool active = true);
  
  bool get_preview_widget_active() const;

  
  Glib::ustring get_preview_filename() const;
  
  Glib::ustring get_preview_uri() const;

/* Extra widget
 */
  
  void set_extra_widget(Gtk::Widget& extra_widget);
  
  Gtk::Widget* get_extra_widget();
  
  const Gtk::Widget* get_extra_widget() const;

/* List of user selectable filters
 */
  
  void add_filter(const Glib::RefPtr<FileFilter>& filter);
  
  void remove_filter (const Glib::RefPtr<FileFilter>& filter);

  //TODO: Const version:
  
  Glib::SListHandle< Glib::RefPtr<FileFilter> > list_filters();

/* Current filter
 */
  
  void set_filter(const Glib::RefPtr<FileFilter>& filter);
  
  Glib::RefPtr<FileFilter> get_filter();
  
  Glib::RefPtr<const FileFilter> get_filter() const;
  
/* Per-application shortcut folders */

  
  bool add_shortcut_folder(const Glib::ustring& folder);
  
  bool remove_shortcut_folder(const Glib::ustring& folder);
  
  Glib::SListHandle<Glib::ustring> list_shortcut_folders() const;

  
  bool add_shortcut_folder_uri(const Glib::ustring& folder);
  
  bool remove_shortcut_folder_uri(const Glib::ustring& folder);
  
  Glib::SListHandle<Glib::ustring> list_shortcut_folder_uris() const;


  //TODO: _WRAP_SIGNAL(void current_folder_changed(), "current_folder_changed")
  //TODO: _WRAP_SIGNAL(void selection_changed(), "selection_changed")
  //TODO: _WRAP_SIGNAL(void update_preview(), "update_preview")
  //TODO: _WRAP_SIGNAL(void file_activated(), "file_activated")

  /**
 * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
 * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
 * the value of the property changes.
 */
Glib::PropertyProxy<FileChooserAction> property_action();

  //_WRAP_PROPERTY("file-system", FileSystem) //construct-only
  /**
 * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
 * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
 * the value of the property changes.
 */
Glib::PropertyProxy< Glib::RefPtr<FileFilter> > property_filter();
 //TODO: Use RefPtr?
  /**
 * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
 * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
 * the value of the property changes.
 */
Glib::PropertyProxy<bool> property_folder_mode();

  /**
 * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
 * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
 * the value of the property changes.
 */
Glib::PropertyProxy<bool> property_local_only();

  /**
 * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
 * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
 * the value of the property changes.
 */
Glib::PropertyProxy<Widget*> property_preview_widget();
 //TODO: Use RefPtr?
  /**
 * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
 * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
 * the value of the property changes.
 */
Glib::PropertyProxy<bool> property_preview_widget_active();

  /**
 * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
 * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
 * the value of the property changes.
 */
Glib::PropertyProxy<Widget*> property_extra_widget();
 //TODO: Use RefPtr?
  /**
 * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
 * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
 * the value of the property changes.
 */
Glib::PropertyProxy<bool> property_select_multiple();

  /**
 * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
 * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
 * the value of the property changes.
 */
Glib::PropertyProxy<bool> property_show_hidden();


  //TODO: vfuncs


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Gtk


namespace Glib
{

/** @relates Gtk::FileChooser */
Glib::RefPtr<Gtk::FileChooser> wrap(GtkFileChooser* object, bool take_copy = false);

} // namespace Glib

#endif /* _GTKMM_FILECHOOSER_H */

