// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_TOOLBAR_H
#define _GTKMM_TOOLBAR_H

#include <glibmm.h>

/* $Id: toolbar.hg,v 1.6 2003/11/22 18:58:22 murrayc Exp $ */

/* Copyright (C) 1998-2002 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/toolitem.h>
#include <glibmm/helperlist.h>
#include <gtkmm/container.h>
#include <gtkmm/stockid.h>

#include <gtkmm/toolbar_elements.h> //deprecated helper API


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkToolbar GtkToolbar;
typedef struct _GtkToolbarClass GtkToolbarClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class Toolbar_Class; } // namespace Gtk
namespace Gtk
{


/** @defgroup Toolbars Toolbar classes
 */

class Toolbar;
class RadioButtonGroup;

namespace Toolbar_Helpers
{

//Forward declaration, needed when GTKMM_DISABLE_DEPRECATED is defined.
class ToolList;

#ifndef GTKMM_DISABLE_DEPRECATED

 
//TODO: I think that we must deprecate ToolList because we must deprecate Tool because it
//derives from the deprecated GtkToolBarChild. Or maybe we can reimplement it in another way.
//murrayc
  
  
class ToolList : public Glib::HelperList< Tool, const Element, Glib::List_Iterator< Tool > >
{
public:
  ToolList();
  explicit ToolList(GtkToolbar* gparent);
  ToolList(const ToolList& src);
  virtual ~ToolList() {}

  ToolList& operator=(const ToolList& src);

  typedef Glib::HelperList< Tool, const Element,  Glib::List_Iterator< Tool > > type_base;

  GtkToolbar* gparent();
  const GtkToolbar* gparent() const;

  virtual GList*& glist() const;      // front of list

  virtual void erase(iterator start, iterator stop);
  virtual iterator erase(iterator);  //Implented as custom or by LIST_CONTAINER_REMOVE
  virtual void remove(const_reference); //Implented as custom or by LIST_CONTAINER_REMOVE

  /// This is order n. (use at own risk)
  reference operator[](size_type l) const;

public:
  iterator insert(iterator position, element_type& e); //custom-implemented.

  template <class InputIterator>
  inline void insert(iterator position, InputIterator first, InputIterator last)
  {
    for(;first != last; ++first)
      position = insert(position, *first);
  }

 inline void push_front(element_type& e)
    { insert(begin(), e); }
  inline void push_back(element_type& e)
    { insert(end(), e); }


  //The standard iterator, instead of List_Cpp_Iterator,
  //only works because Child is derived from GtkToolbarChild.

  virtual void remove(Widget& widget);
  
  iterator find(const_reference c);
  iterator find(Widget&);

  };


#endif //GTKMM_DISABLE_DEPRECATED

} //namespace Toolbar_Helpers


/** Bars of buttons and other widgets.
 * The STL-style container is available via the tools() method.
 * @ingroup Widgets
 * @ingroup Containers
 * @ingroup Toolbars
 */

class Toolbar : public Container
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Toolbar CppObjectType;
  typedef Toolbar_Class CppClassType;
  typedef GtkToolbar BaseObjectType;
  typedef GtkToolbarClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Toolbar();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class Toolbar_Class;
  static CppClassType toolbar_class_;

  // noncopyable
  Toolbar(const Toolbar&);
  Toolbar& operator=(const Toolbar&);

protected:
  explicit Toolbar(const Glib::ConstructParams& construct_params);
  explicit Toolbar(GtkToolbar* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GtkToolbar*       gobj()       { return reinterpret_cast<GtkToolbar*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GtkToolbar* gobj() const { return reinterpret_cast<GtkToolbar*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_orientation_changed(Orientation orientation);
  virtual void on_toolbar_style_changed(ToolbarStyle style);
  virtual bool on_popup_context_menu(int x, int y, int button_number);


private:

public:

#ifndef GTKMM_DISABLE_DEPRECATED
  typedef Toolbar_Helpers::ToolList ToolList;
#endif //GTKMM_DISABLE_DEPRECATED

  Toolbar();

  //TODO: Add SigC::Slot parameter as well?
  
  void insert(ToolItem& item, int pos);
  void append(ToolItem& item);
  void prepend(ToolItem& item);
  
  
  int get_item_index(const ToolItem& item);
  
  int get_n_items() const;
  
  ToolItem* get_nth_item(int n);
  
  const ToolItem* get_nth_item(int n) const;
  
  bool get_show_arrow() const;
  
  void set_show_arrow(bool show_arrow = true);


/* Style methods */
  
  void set_orientation(Orientation orientation);
  
  Orientation get_orientation() const;

  
  void set_toolbar_style(ToolbarStyle style);
  
  ToolbarStyle get_toolbar_style() const;

  
  void set_tooltips(bool enable = true);
  
  bool get_tooltips() const;

  
  void set_icon_size(IconSize icon_size);
  
  IconSize get_icon_size() const;

  
  void unset_toolbar_style();
  
  void unset_icon_size();
 
  
  ReliefStyle get_relief_style() const;
  
  int get_drop4_index(int x, int y) const;
  
  void set_drop_highlight_item(ToolItem& tool_item, int index);
  void unset_drop_highlight_item();


  #ifndef GTKMM_DISABLE_DEPRECATED

  ///STL-style container.
  ToolList& tools();
  
  ///STL-style container.
  const ToolList& tools() const;

  typedef Toolbar_Helpers::Callback0 Callback0;
  Gtk::Widget* append_item(const Glib::ustring& text, const Glib::ustring& tooltip_text, const Glib::ustring& tooltip_private_text,
    Gtk::Widget& icon, Callback0 slot);
  Gtk::Widget* append_item(const Glib::ustring& text, const Glib::ustring& tooltip_text, const Glib::ustring& tooltip_private_text,
    Callback0 slot);
  
    
  Gtk::Widget* prepend_item(const Glib::ustring& text, const Glib::ustring& tooltip_text, const Glib::ustring& tooltip_private_text,
    Gtk::Widget& icon, Callback0 slot);
  Gtk::Widget* prepend_item(const Glib::ustring& text, const Glib::ustring& tooltip_text, const Glib::ustring& tooltip_private_text,
    Callback0 slot);
  
    
  Gtk::Widget* insert_item(const Glib::ustring& text, const Glib::ustring& tooltip_text, const Glib::ustring& tooltip_private_text,
    Gtk::Widget& icon, Callback0 slot,
    int position);
  Gtk::Widget* insert_item(const Glib::ustring& text, const Glib::ustring& tooltip_text, const Glib::ustring& tooltip_private_text,
    Callback0 slot,
    int position);
  

  Gtk::Widget* insert_stock(const Gtk::StockID& stock_id, const Glib::ustring& tooltip_text, const Glib::ustring& tooltip_private_text,
    Callback0 slot,
    int position);
  

  void append_space();
  
  void prepend_space();
  
  void insert_space(int position);
  
  void remove_space(int position);

  
  void append_widget(Gtk::Widget& widget, const Glib::ustring& tooltip_text = Glib::ustring(), const Glib::ustring& tooltip_private_text = Glib::ustring());
  
  void prepend_widget(Gtk::Widget& widget, const Glib::ustring& tooltip_text = Glib::ustring(), const Glib::ustring& tooltip_private_text = Glib::ustring());
  
  void insert_widget(Gtk::Widget& widget, const Glib::ustring& tooltip_text, const Glib::ustring& tooltip_private_text, int position);

  //Let's not wrap gtk_toolbar_*_element(), because they don't do anything extra, and it's an unclear API.
  

  #endif //GTKMM_DISABLE_DEPRECATED

  
  /**
   * @par Prototype:
   * <tt>void %orientation_changed(Orientation orientation)</tt>
   */
  Glib::SignalProxy1< void,Orientation > signal_orientation_changed();

  
  /**
   * @par Prototype:
   * <tt>void %toolbar_style_changed(ToolbarStyle style)</tt>
   */
  Glib::SignalProxy1< void,ToolbarStyle > signal_toolbar_style_changed();

  
  /**
   * @par Prototype:
   * <tt>bool %popup_context_menu(int x, int y, int button_number)</tt>
   */
  Glib::SignalProxy3< bool,int,int,int > signal_popup_context_menu();

  
  /**
 * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
 * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
 * the value of the property changes.
 */
Glib::PropertyProxy<Orientation> property_orientation();

  /**
 * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
 * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
 * the value of the property changes.
 */
Glib::PropertyProxy<ToolbarStyle> property_toolbar_style();

  /**
 * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
 * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
 * the value of the property changes.
 */
Glib::PropertyProxy<bool> property_show_arrow();


protected:
  //deprecated:
  //We use a pointer, because that allows us only to declare the type
  //with a prototype, so we can deprecate the type.
  typedef std::auto_ptr<Toolbar_Helpers::ToolList> tools_proxy_ptr_type;
  mutable tools_proxy_ptr_type tools_proxy_;


};

} // namespace Gtk


namespace Glib
{
  /** @relates Gtk::Toolbar */
  Gtk::Toolbar* wrap(GtkToolbar* object, bool take_copy = false);
}
#endif /* _GTKMM_TOOLBAR_H */

